import { Component, OnInit, Input, OnChanges } from '@angular/core';
import { Router } from '@angular/router';
import { MetaCrawler } from '../../../../meta/crawler/model/MetaCrawler';

import { Store, select } from '@ngrx/store';
import { RPCError } from 'packages/core/rpc/error';
import * as ListStore from 'packages/meta/crawler-input-item/store/list';
import { ReadCrawlerInputItemSelector } from 'packages/meta/crawler-input-item/store';
import { MetaCrawlerInputItem } from '../../../../meta/crawler-input-item/model/MetaCrawlerInputItem';


@Component({
  selector: 'of-crawler-auth',
  templateUrl: './crawler-auth.component.html',
  styleUrls: ['./crawler-auth.component.scss']
})
export class CrawlerAuthComponent implements OnInit, OnChanges {

  inputItems$ = this.listStore.pipe(select(ReadCrawlerInputItemSelector.select('inputs')));
  inputItems: MetaCrawlerInputItem[];

  @Input() selectedCrawler: MetaCrawler;
  constructor(
    private router: Router,
    private listStore: Store<ListStore.State>,
  ) { }

  ngOnInit() {
    this.inputItems$.subscribe(
      (list: MetaCrawlerInputItem[]) => {
        if (list !== null) {
          console.log('###Auth Inputs###');
          console.log(list);
          console.log('###################');
          this.inputItems = list;
          this.generateAuthComponent();
        }
      },
      (error: RPCError) => {
        console.log(error.response.message);
      }
    );
  }

  ngOnChanges() {
    if (this.selectedCrawler === null) { return; }
    this.getCrawlerAuthInputItems();
  }

  getCrawlerAuthInputItems() {
    this.listStore.dispatch(new ListStore.ReadAll(this.selectedCrawler));
  }

  generateAuthComponent() {
    this.inputItems.map(function(v, i) {
    });
  }
}
